
using namespace std;

#include "termios.h"
#include "sys/time.h"

#include "ARToolKitPlus/TrackerSingleMarkerImpl.h"

#include "GestioneConfigurazione.h"
#include "MatrixFunctions.h"
#include "Matrix3DRotoTraslation.h"
#include "Param3DRotoTraslation.h"
#include "VideoAcquisitionWheelchair.h"
#include "FileRawAcquisition.h"
#include "InverseMatrixCorrection.h"
#include "VisionSystemCalibHeader.h"
#include "WheelChairUtil.h"



//questa è doppia... ma è un po' un casino tirarla fuori dal VisionExpert 
int initInvMatFromFile(InverseMatrixCorrection *invMat){
	vector<int> 	tagNum;
	vector<double> 	zeta;
	vector<double> 	beta;
	vector<double> 	gamma;

	using namespace po;
	options_description generic;
	variables_map vm;	
	try {
		generic.add_options()
		    ("tagNumber", 	value<vector<int> >(&tagNum), 					"list of knew tags")
		    ("tagZeta", 	value<vector<double> >(&zeta), 					"zeta of knew tags")
		    ("tagBeta", 	value<vector<double> >(&beta), 					"beta of knew tags")
		    ("tagGamma", 	value<vector<double> >(&gamma), 				"gamma of knew tags")
		    ;
	       
		ifstream ifs(GestioneConfigurazione::getMatrixInversionParameterFile().c_str());
		store(parse_config_file(ifs, generic), vm);
		notify(vm);
	}
	catch (exception& e){
		cout << e.what() << "\n";
		return -1;
	}        
	if(tagNum.size()!=zeta.size())return -1;
	if(tagNum.size()!=beta.size())return -1;
	if(tagNum.size()!=gamma.size())return -1;
	for(int i=0;i<tagNum.size();i++){
		invMat->addTag(tagNum[i],zeta[i],beta[i],gamma[i]);
		DBG("inv correction added %d\n",tagNum[i]);
	}
	return 0;
}

void mediaFile(){
	int t1,t2;
	double tmp;
	FILE *f=fopen(GestioneConfigurazione::getTagRelationFileTmp().c_str(),"r");
	if(f==NULL){
		cout<<"ERRORE APERTURA FILE "<<GestioneConfigurazione::getTagRelationFileTmp().c_str()<<endl;
		return ;
	}
	map< int, map <int,int > >tagCount;
	map< int, map <int,double> >tagX;
	map< int, map <int,double> >tagY;
	map< int, map <int,double > >tagZ;
	map< int, map <int,double > >tagSA;
	map< int, map <int,double > >tagCA;
	map< int, map <int,double > >tagSB;
	map< int, map <int,double > >tagCB;
	map< int, map <int,double > >tagSC;
	map< int, map <int,double > >tagCC;

	while(!feof(f)){
		fscanf(f,"%d",&t1);
		fscanf(f,"%d",&t2);
		if(feof(f))break;
		if(tagCount.find(t1)==tagCount.end()){
			map <int,int> mc;
			mc[t2]=0;
			tagCount[t1]=mc;

			map <int,double > mx;
			mx[t2]=0;
			tagX[t1]=mx;

			map <int,double > my;
			my[t2]=0;
			tagY[t1]=my;

			map <int,double > mz;
			mz[t2]=0;
			tagZ[t1]=mz;

			map <int,double>  msa;
			msa[t2]=0;
			tagSA[t1]=msa;

			map <int,double>  mca;
			mca[t2]=0;
			tagCA[t1]=mca;

			map <int,double>  msb;
			msb[t2]=0;
			tagSB[t1]=msb;

			map <int,double>  mcb;
			mcb[t2]=0;
			tagCB[t1]=mcb;

			map <int,double>  msc;
			msc[t2]=0;
			tagSC[t1]=msc;

			map <int,double>  mcc;
			mcc[t2]=0;
			tagCC[t1]=mcc;
		}
		else{
			//il primo indice esiste, 
			if(tagCount[t1].find(t2)==tagCount[t1].end()){
				tagCount[t1][t2]=0;
				tagX[t1][t2]=0;
				tagY[t1][t2]=0;
				tagZ[t1][t2]=0;
				tagSA[t1][t2]=0;
				tagCA[t1][t2]=0;
				tagSB[t1][t2]=0;
				tagCB[t1][t2]=0;
				tagSC[t1][t2]=0;
				tagCC[t1][t2]=0;
			}
		}
		tagCount[t1][t2]++;
		fscanf(f,"%lf",&tmp);
		tagX[t1][t2]+=tmp;
		fscanf(f,"%lf",&tmp);
		tagY[t1][t2]+=tmp;
		fscanf(f,"%lf",&tmp);
		tagZ[t1][t2]+=tmp;
		fscanf(f,"%lf",&tmp);
		tagSA[t1][t2]+=tmp;
		fscanf(f,"%lf",&tmp);
		tagCA[t1][t2]+=tmp;
		fscanf(f,"%lf",&tmp);
		tagSB[t1][t2]+=tmp;
		fscanf(f,"%lf",&tmp);
		tagCB[t1][t2]+=tmp;
		fscanf(f,"%lf",&tmp);
		tagSC[t1][t2]+=tmp;
		fscanf(f,"%lf",&tmp);
		tagCC[t1][t2]+=tmp;
	}
	fclose(f);

	f=fopen(GestioneConfigurazione::getTagRelationFileMeanTmp().c_str(),"w");
	if(f==NULL){
		cout<<"ERRORE APERTURA FILE "<<GestioneConfigurazione::getTagRelationFileMeanTmp().c_str()<<endl;
		return ;
	}
	for(map< int, map <int,int > >::iterator i=tagCount.begin();i!=tagCount.end();i++){
		for(map <int,int >::iterator j=tagCount[i->first].begin();j!=tagCount[i->first].end();j++){
			fprintf(f,"%d\t%d\t%d\t",i->first,j->first,tagCount[i->first][j->first]);
			fprintf(f,"%.16f\t",tagX[i->first][j->first]/tagCount[i->first][j->first]);
			fprintf(f,"%.16f\t",tagY[i->first][j->first]/tagCount[i->first][j->first]);
			fprintf(f,"%.16f\t",tagZ[i->first][j->first]/tagCount[i->first][j->first]);
			fprintf(f,"%.16f\t",tagSA[i->first][j->first]/tagCount[i->first][j->first]);
			fprintf(f,"%.16f\t",tagCA[i->first][j->first]/tagCount[i->first][j->first]);
			fprintf(f,"%.16f\t",tagSB[i->first][j->first]/tagCount[i->first][j->first] );
			fprintf(f,"%.16f\t",tagCB[i->first][j->first]/tagCount[i->first][j->first]);
			fprintf(f,"%.16f\t",tagSC[i->first][j->first]/tagCount[i->first][j->first] );
			fprintf(f,"%.16f\t\n",tagCC[i->first][j->first]/tagCount[i->first][j->first]);

			printf("%d %d %d ",i->first,j->first,tagCount[i->first][j->first]);
			printf("%.3f ",tagX[i->first][j->first]/tagCount[i->first][j->first]);
			printf("%.3f ",tagY[i->first][j->first]/tagCount[i->first][j->first]);
			printf("%.3f ",tagZ[i->first][j->first]/tagCount[i->first][j->first]);
			printf("%.3f ",tagSA[i->first][j->first]/tagCount[i->first][j->first]);
			printf("%.3f ",tagCA[i->first][j->first]/tagCount[i->first][j->first]);
			printf("%.3f ",tagSB[i->first][j->first]/tagCount[i->first][j->first] );
			printf("%.3f ",tagCB[i->first][j->first]/tagCount[i->first][j->first]);
			printf("%.3f ",tagSC[i->first][j->first]/tagCount[i->first][j->first] );
			printf("%.3f \n",tagCC[i->first][j->first]/tagCount[i->first][j->first]);
		}
	}	
	fclose(f);
}

Matrix3DRotoTraslation  * calcMatrix(ARToolKitPlus::TrackerSingleMarker* tracker){
	Matrix3DRotoTraslation *matrix=new Matrix3DRotoTraslation();
	bool allZero=true;
	for(int j=0; j<3; j++){//faccio solo le prime tre righe, la quarta è [0 0 0 1]
		for(int i=0; i<4; i++){
			matrix->setValue(j,i,tracker->getModelViewMatrix()[i*4+j]);
			if(!(i==3 && j==3)){
				if(fabs(tracker->getModelViewMatrix()[i*4+j])>1e-6){
					//printf("artoolkit::allzero=false\n");
					allZero=false;
				}
			}
		}
	}
	//se allZero=true, la matrice non è valida! (anche se markerId è >=0 capita)
	if(!allZero){
		//matrice valida
		return matrix;
	}
	//else
	delete matrix;
	return NULL;
}


int analyseTagRelation(){
	FILE *fout=fopen(GestioneConfigurazione::getTagRelationFileTmp().c_str(),"w");
	if(fout==NULL){
		cout<<"ERRORE APERTURA FILE "<<GestioneConfigurazione::getTagRelationFileTmp().c_str()<<endl;
		return -1;
	}

	const int     width = 640, height = 480;
	/*size_t        numPixels = width*height*bpp;
	size_t        numBytesRead;*/
	struct timeval tv,tv2,r;
	struct timezone tz;
	bool exit=false;
	unsigned int count=0;
	char c;

	MyLogger      logger;
	ARToolKitPlus::TrackerSingleMarker* tracker = new ARToolKitPlus::TrackerSingleMarkerImpl<6,6,6, 1, 8>(width,height);

	//inizializzazione tracker
	tracker->setLogger(&logger);
	tracker->setPixelFormat(ARToolKitPlus::PIXEL_FORMAT_LUM);
	if(!tracker->init(GestioneConfigurazione::getArtoolkitCalibFile().c_str(), 1.0f, 1000.0f)){
		printf("ERROR: artoolkit init\n");
		delete tracker;
		return -1;	
	}
	// define size of the marker
	tracker->setPatternWidth(GestioneConfigurazione::getArtoolkitTagDimension());
	tracker->setBorderWidth( 0.250f);
	tracker->activateAutoThreshold(true);
	tracker->setUndistortionMode(ARToolKitPlus::UNDIST_LUT);
	tracker->setPoseEstimator(ARToolKitPlus::POSE_ESTIMATOR_RPP);
	tracker->setMarkerMode( ARToolKitPlus::MARKER_ID_SIMPLE);
	
	VideoAcquisitionWheelchair * camera;
	camera=new FileRawAcquisition(GestioneConfigurazione::getImageNamePrefix(),GestioneConfigurazione::getImageNameSubfix(),GestioneConfigurazione::getImageNameFormat());

	InverseMatrixCorrection * invMat1= new InverseMatrixCorrection();
	if(initInvMatFromFile(invMat1)!=0){
		fprintf(stderr,"vision::error in inverse matrix init\n");
		delete tracker;
		delete invMat1;
		return -1;
	}
	InverseMatrixCorrection * invMat2= new InverseMatrixCorrection();
	if(initInvMatFromFile(invMat2)!=0){
		fprintf(stderr,"vision::error in inverse matrix init\n");
		delete tracker;
		delete invMat1;
		delete invMat2;
		return -1;
	}


	camera->Start();
	set_keypress();
	unsigned char * img;
	gettimeofday(&tv,&tz);

	while(!exit){
		map<int,Matrix3DRotoTraslation *> frameMat;
		c=getchar();
		if(c==27)exit=true;
		img=camera->CaptureFrame();
		if(img==NULL){
			printf("END!\n");
			exit =true;
		}
		if(!exit){
			ARToolKitPlus::ARMarkerInfo* markerInfo;
			int numMarkers;
			//così trova il marker migliore
			int markerId = tracker->calc(img,-1,true, &markerInfo,&numMarkers);
			if(markerId>=0){
				printf("id trovato: %d\n",markerId);
				Matrix3DRotoTraslation * m=calcMatrix(tracker);
				if(m!=NULL)frameMat[markerId]=m;
			}

			//ora tratto gli altri marker trovati
			vector<int> tagIdentificati;
			for(int j = 0; j < numMarkers; j++){
				if(markerInfo[j].id!=-1){
					bool exist=false;
					for(int i=0;i<tagIdentificati.size();i++){
						if(tagIdentificati[i]==markerInfo[j].id){
							exist=true;
							break;
						}
					}
					if(!exist && markerInfo[j].id!=markerId){
						printf("altro id trovato: %d\n",markerInfo[j].id);
						tagIdentificati.push_back(markerInfo[j].id);
					}
				}
			}
			
			for(int i=0;i<tagIdentificati.size();i++){
				//ricerca esplicita del tag
				int markerId = tracker->calc(img,tagIdentificati[i]);
				if(markerId>=0){
					Matrix3DRotoTraslation * m=calcMatrix(tracker);
					if(m!=NULL)frameMat[markerId]=m;
				}
			}
			//ora nell'oggeto frameMat ho tutte le matrici da telecamera ai tag presenti nel frame
			map<int,Matrix3DRotoTraslation *>::iterator iter,iter2;

			
			while(!frameMat.empty()){
				iter=frameMat.begin();
				iter2 = frameMat.begin();
				iter2++;
				for( ; iter2 != frameMat.end(); iter2++ ) {
					//prendo la matrice diretta rispetto al secondo tag con zeta beta e gamma mediate
					if(invMat2->getCorrectedMatrix(iter2->second,iter2->first)==0){
						if(invMat1->getInverseMatrix(iter->second,iter->first)==0){
							Matrix3DRotoTraslation * res=multMatrix3D(invMat1->getResult(),invMat2->getResult());
							Param3DRotoTraslation *rp=toParam3DRotoTraslation(res);
							delete res;
							fprintf(fout,"%d %d %.16f\t%.16f\t%.16f\t%.16f\t%.16f\t%.16f\t%.16f\t%.16f\t%.16f\n",iter->first,iter2->first,rp->getX(),rp->getY(),rp->getZ(),rp->getSinA(),rp->getCosA(),rp->getSinB(),rp->getCosB(),rp->getSinC(),rp->getCosC());
							printf("%d %d %.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\n",iter->first,iter2->first,rp->getX(),rp->getY(),rp->getZ(),rp->getA(),rp->getB(),rp->getC());
							delete rp;							
						}
					}
					
				}
				delete iter->second;
				frameMat.erase(frameMat.begin());
			}					
			
						
			printf("COUNT=%d\n",count);
			count++;
		}
		
	}
	gettimeofday(&tv2,&tz);//temporizzazione del ciclo di controllo
	timersub(&tv2,&tv,&r);
	printf("tempo trascorso: %u.%.6u\n",r.tv_sec,r.tv_usec);
	double fps=((double)count)/((double)((double)r.tv_sec+(double)r.tv_usec/(double)1000000.0));
	printf("fps: %lf\n",fps);

	reset_keypress();

	fclose(fout);
	camera->Stop();
	delete tracker;
	delete camera;
	return 0;	

}

int main(int argc,char *argv[]){
	if(GestioneConfigurazione::init("config/config.ini",argc,argv)!=0)exit(0);
	cout<<"analisi immagini..."<<endl;
		string s;
		s="cp "+GestioneConfigurazione::getTagRelationFileTmp()+" "+ GestioneConfigurazione::getTagRelationFileTmp()+".old";

		
	if(analyseTagRelation()==0){
		printf("OK");
		s="cp "+GestioneConfigurazione::getTagRelationFileMeanTmp()+" "+ GestioneConfigurazione::getTagRelationFileMeanTmp()+".old";

		mediaFile();
		printf("end");
	}

}


