
using namespace std;

#include "termios.h"
#include "sys/time.h"

#include "ARToolKitPlus/TrackerSingleMarkerImpl.h"

#include "GestioneConfigurazione.h"
#include "MatrixFunctions.h"
#include "Matrix3DRotoTraslation.h"
#include "Param3DRotoTraslation.h"
#include "VideoAcquisitionWheelchair.h"
#include "FileRawAcquisition.h"
#include "InverseMatrixCorrection.h"
#include "VisionSystemCalibHeader.h"
#include "WheelChairUtil.h"

//questa e' doppia... ma e' un po' un casino tirarla fuori dal VisionExpert 

Matrix3DRotoTraslation * loadAbsSdrToTag(int *toTag){
	Param3DRotoTraslation * p=new Param3DRotoTraslation();
	Matrix3DRotoTraslation *m;
	double 	x;
	double 	y;
	double 	z;
	double 	a;
	double 	b;
	double 	c;
	
	using namespace po;
	options_description generic;
	variables_map vm;	
	try {
		generic.add_options()
		    ("toTag", 		value<int>(toTag)->default_value(0), 					"x")
		    ("x", 		value<double >(&x)->default_value(0), 					"x")
		    ("y", 		value<double >(&y)->default_value(0), 					"y")
		    ("z", 		value<double >(&z)->default_value(0), 					"z")
		    ("alpha", 		value<double >(&a)->default_value(0), 					"a")
		    ("beta", 		value<double >(&b)->default_value(0), 					"b")
		    ("gamma", 		value<double >(&c)->default_value(0), 					"g")
		    ;
	       
		ifstream ifs(GestioneConfigurazione::GestioneConfigurazione::getMatrixSdrAbsoluteWrtTagFileTmp().c_str());
		store(parse_config_file(ifs, generic), vm);
		notify(vm);
	}
	catch (exception& e){
		cout << e.what() << "\n";
		exit(-1);
		return NULL;
	}        
	
	p->setX(x);
	p->setY(y);
	p->setZ(z);
	p->setA(a);
	p->setB(b);
	p->setC(c);
	printf("abs to tag %d: %.3f %.3f %.3f %.3f %.3f %.3f\n",*toTag,x,y,z,a,b,c);
	m=toMatrix3DRotoTraslation(p);
	delete p;
	return m;
}

map< int, map <int, Matrix3DRotoTraslation *> > loadFromFile(){
	int t1,t2,t3;
	double tmp,tmp2;
	map< int, map <int, Matrix3DRotoTraslation *> > loadedMatrix;
	Param3DRotoTraslation * p=new Param3DRotoTraslation();
	FILE *f=fopen(GestioneConfigurazione::getTagRelationFileMeanTmp().c_str(),"r");
	if(f==NULL){
		cout<<"ERRORE APERTURA FILE "<<GestioneConfigurazione::getTagRelationFileMeanTmp().c_str()<<endl;
		exit(-1);
		return loadedMatrix;
	}


	while(!feof(f)){
		fscanf(f,"%d",&t1);
		if(feof(f))break;
		fscanf(f,"%d",&t2);
		if(loadedMatrix.find(t1)==loadedMatrix.end()){
			map <int, Matrix3DRotoTraslation *> mat;
			loadedMatrix[t1]=mat;
		}
		fscanf(f,"%d",&t3);//leggo il count
		printf("%d %d %d ",t1,t2,t3);

		fscanf(f,"%lf",&tmp);
		p->setX(tmp);
		printf("%.3f ",tmp);
		fscanf(f,"%lf",&tmp);
		printf("%.3f ",tmp);
		p->setY(tmp);
		fscanf(f,"%lf",&tmp);
		printf("%.3f ",tmp);
		p->setZ(tmp);
		fscanf(f,"%lf",&tmp);
		printf("%.3f ",tmp);
		fscanf(f,"%lf",&tmp2);
		printf("%.3f ",tmp2);
		p->setA(tmp,tmp2);
		fscanf(f,"%lf",&tmp);
		printf("%.3f ",tmp);
		fscanf(f,"%lf",&tmp2);
		printf("%.3f ",tmp2);
		p->setB(tmp,tmp2);
		fscanf(f,"%lf",&tmp);
		printf("%.3f ",tmp);
		fscanf(f,"%lf",&tmp2);
		printf("%.3f\n",tmp2);
		p->setC(tmp,tmp2);
		loadedMatrix[t1][t2]=toMatrix3DRotoTraslation(p);
	}

	fclose(f);
	return loadedMatrix;
}

void printRelation(map< int, map <int, Matrix3DRotoTraslation *> > relation){
	for(map< int, map <int, Matrix3DRotoTraslation *> >::iterator i=relation.begin();i!=relation.end();i++){
		for(map <int, Matrix3DRotoTraslation *>::iterator j=relation[i->first].begin();j!=relation[i->first].end();j++){
			printf("%d->%d\n",i->first,j->first);
		}
	}
}


int main(int argc,char *argv[]){
	if(GestioneConfigurazione::init("config/config.ini",argc,argv)!=0)exit(0);
	cout<<"analisi immagini..."<<endl;

	string s;
	s="cp "+GestioneConfigurazione::getAbsoluteCoordinateTagRelationFile()+" "+ GestioneConfigurazione::getAbsoluteCoordinateTagRelationFile()+".old";
	system(s.c_str());
	cout<<s<<endl;
	Matrix3DRotoTraslation * m;	
	int toTag;
	map< int, map <int, Matrix3DRotoTraslation *> > relation;
	relation=loadFromFile();
	m= loadAbsSdrToTag(&toTag);
	relation[-1][toTag]=m;

	bool ex=false;	
	int t1,t2,t3;
	while(!ex){
		printRelation(relation);
		printf("numero tag partenza (-1 ass) (-99 per uscire) (-2 per invertire una relazione):");
		scanf("%d",&t1);
		if(t1==-99)ex=true;
		if(!ex){
			if(t1==-2){			
				printf("numero tag partenza:");
				scanf("%d",&t1);
				printf("numero tag arrivo:");
				scanf("%d",&t2);
				if(relation.find(t1)==relation.end()){
					printf("%d non e' un tag valido di partenza\n",t1);
				}
				else{
					if(relation[t1].find(t2)==relation[t1].end()){
						printf("%d non e' un tag valido di arrivo\n",t2);
					}
					else{
						bool write=true;
						if(relation.find(t2)!=relation.end()){
							if(relation[t2].find(t1)!=relation[t2].end()){
								write=false;
								char c;
								do{
									c=getchar();
									if(c=='S'||c=='s'){
										write=true;
										break;
									}
									if(c=='N'||c=='n'){
										break;
									}
								}while(1);
							}
						}
						else{
							map <int, Matrix3DRotoTraslation *>  tr;
							relation[t2]=tr;
						}
						if(write){
							printf("relazione %d->%d creata\n",t2,t1);
							relation[t2][t1]=invMatrix3D(relation[t1][t2]);
						}
						
					}
				}
	
			}	
			else{
				printf("numero tag passaggio:");
				scanf("%d",&t2);
				printf("numero tag arrivo: ");
				scanf("%d",&t3);
				if(relation.find(t1)==relation.end()){
					printf("%d non e' un tag valido di partenza\n",t1);
				}
				else{
					if(relation[t1].find(t2)==relation[t1].end()){
						printf("%d non e' un tag valido di passaggio (1)\n",t2);
					}
					else{
						if(relation.find(t2)==relation.end()){
							printf("%d non e' un tag valido di passaggio (2)\n",t2);
						}
						else{
							if(relation[t2].find(t3)==relation[t2].end()){
								printf("%d non e' un tag valido di arrivo \n",t2);
							}
							else{
								//tutto ok
								if(relation[t1].find(t3)!=relation[t1].end()){
									printf("cancellare la relazione %d->%d e sostiuirla con quella attuale (s\n)?",t1,t3);
									char c;
									do{
										c=getchar();
										if(c=='S'||c=='s'){
											relation[t1][t3]=multMatrix3D(relation[t1][t2],relation[t2][t3]);
											printf("relazione %d->%d creata!",t1,t3);
											break;
										}
										if(c=='N'||c=='n'){
											break;
										}
									}while(1);
								}
								else{
									relation[t1][t3]=multMatrix3D(relation[t1][t2],relation[t2][t3]);
									printf("relazione %d->%d creata!",t1,t3);	
								}
								printf("creata relazione da %d a %d\n",t1,t3);
							}
						}
					}
				}
			}
		}
	}
	
	FILE *f=fopen(GestioneConfigurazione::getAbsoluteCoordinateTagRelationFile().c_str(),"w");
	if(f==NULL){
		cout<<"ERRORE APERTURA FILE "<<GestioneConfigurazione::getAbsoluteCoordinateTagRelationFile().c_str()<<endl;
		exit(-1);
		return -1;
	}
	for(map <int, Matrix3DRotoTraslation *>::iterator i=relation[-1].begin();i!=relation[-1].end();i++){
		Param3DRotoTraslation *p=toParam3DRotoTraslation(i->second);
		fprintf(f,"tagNumber\t=%d\n",i->first);
		fprintf(f,"tagX\t=%.16f\n",p->getX());
		fprintf(f,"tagY\t=%.16f\n",p->getY());
		fprintf(f,"tagZ\t=%.16f\n",p->getZ());
		fprintf(f,"tagAlpha\t=%.16f\n",p->getA());
		fprintf(f,"tagBeta\t=%.16f\n",p->getB());
		fprintf(f,"tagGamma\t=%.16f\n\n",p->getC());

		printf("tagNumber\t=%d\n",i->first);
		printf("tagX\t=%.3f\n",p->getX());
		printf("tagY\t=%.3f\n",p->getY());
		printf("tagZ\t=%.3f\n",p->getZ());
		printf("tagAlpha\t=%.3f\n",p->getA());
		printf("tagBeta\t=%.3f\n",p->getB());
		printf("tagGamma\t=%.3f\n\n",p->getC());
		delete p;
	}
	fclose (f);
	return 0;
}


