/**********************************************
 * DCDT                       September 2002  *  
 *                                            *
 * interface.h                                *
 *                                            *
 * originally developed by M.Matteucci        *
 * matteucc@airlab.elet.polimi.it             *
 **********************************************/

#ifndef INTERFA_H
#define INTERFA_H

#include "const.h"
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <DCDT_Agora.h>
#include <DCDT_Msg.h>
#include <DCDT_Member.h>

//#include <qwidget.h>

#include <qpushbutton.h>
#include <qapplication.h>
#include <qlabel.h>
#include <qfont.h>
#include <qtimer.h>
#include <qlayout.h>
#include <qframe.h>

class QInterface;

class Interface : public DCDT_Member
{

 private:
  QInterface *Panel;
  
 public:
  Interface (DCDT_Agora*);
  ~Interface ();
  void Init();
  void Close();
  void DoYourJob(int);

  friend class QInterface;
};

class QInterface : public QWidget
{
  Q_OBJECT

public:
  QInterface(Interface *MyMember=NULL, QWidget *parent=0,const char *nome="QInterface");
  int NumMsg;

private slots:
  void SendClicked();
  void EndClicked();
  void timerEvent();

private:
  Interface *QTMember;

  QBoxLayout *TopLayout;
  QBoxLayout *Buttons;
 
  QPushButton *Send;
  QPushButton *End;
  QTimer *timer;
  QLabel *Label;

};

#endif // INTERFA_H
