/**********************************************
 * DCDT                       January 2002    *  
 *                                            *
 * DCDT_Main.cpp                              *
 *                                            *
 *                                            *
 **********************************************/

#include <DCDT_Agora.h>
#include <DCDT_Member.h>
#include <DCDT_Time.h>

#include "const.h"

#include "member_zero.h"
#include "member_one.h"

#define HAVE_MEMBER0
#define HAVE_MEMBER1

int main(int argc, char **argv) {
  
  DCDT_Agora *agora;
  MemberZero *member0;
  MemberOne *member1;
  
  agora = new DCDT_Agora("../dcdt.conf"); 

#ifdef HAVE_MEMBER0
  member0 = new MemberZero(agora);
  agora->AddMember(member0);
#endif

#ifdef HAVE_MEMBER1
  member1 = new MemberOne(agora);
  agora->AddMember(member1);
#endif

  printf("\n\nPress a key to create the Community\n\n");
  getchar();

#ifdef HAVE_MEMBER0
  agora->ActivateMember(member0);
#endif

#ifdef HAVE_MEMBER1
  agora->ActivateMember(member1);
#endif

  printf("\n\nPress a key and ''let's work, be proud...'' \n\n");

  agora->LetsWork();

#ifdef HAVE_MEMBER0      
  delete member0;
#endif

#ifdef HAVE_MEMBER1
  delete member1;
#endif

  delete agora;

  printf("\n\nCommunity Session Terminated\n\n");

  return 0;
}
