/****************************************************************************
dEVICE cOMMUNITIES dEVELOPMENT tOOLKIT 

DCDT_InnerLinkManager.h

COPYRIGHT (C) 2002   Alessandro Mazzini (mazzini@airlab.elet.polimi.it)
          (C) 2003   Cristian Giussani (cgiussani@fastflow.it)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.

****************************************************************************/

#ifndef INNERLINKMAN_H
#define INNERLINKMAN_H

#include <DCDT_Member.h>
#include <DCDT_InnerChannel.h>
#include <DCDT_LinkRx.h>

#define ILM_RECV_TIMER 3000000

/*! \brief Member that manage the InnerLink.
 *
 *
 */
class DCDT_InnerLinkManager : public DCDT_Member {

 public:
  DCDT_InnerLinkManager(DCDT_Agora* agora);
  ~DCDT_InnerLinkManager();

  void Init();
  void DoYourJob(int par = 0);

  void CreateLink(int status);
  InnerCommData* CreateName(int count);
  void SetCDs(int status);

  //Search for existing Agora on the same machine
  int LookForExistingAgora (int &agoraID);

 private:
  DCDT_InnerChannel *InnerChannel;
  InnerCommData *InnerCD, *InnerStartCD, *localCD, *remoteCD, *name_cd;
  CommData *hs_cd;

  int innerlink_counter;
  char *name;
  HSMsgHeader *hs_header;

};

#endif //define
