#ifndef _LATENCY_TEST_H
#define _LATENCY_TEST_H

#ifdef LATENCY_TEST
#include <latency-graph.h>

#define LAT_INIT(A,B) lat_init(A, B)
#define LAT_DEADLINE(A,B) { \
 lat_set_deadline ( A, B*1.15 ); \
 lat_set_range1 ( A, B*0.98, B*1.02 ); \
 lat_set_range2 ( A, B*0.95, B*1.05 ); \
 lat_set_flags ( A, LAT_SHOW_DEADLINE | LAT_SHOW_RANGE1 | LAT_SHOW_RANGE2 ); \
 lat_set_color_main ( A, 0, 128, 255 ); \
}

#define LAT_SAMPLE(A,B) { \
 static double mytime1=0.0,mytime2; \
 if(lat_check_samplerange(A)) {\
    if(lat_check_sampleranges()) { \
         draw_latency_graph( "latency.gif" ); \
         dump_samples ( "latency.txt" ); \
         B; \
    } \
 } \
 else { \
    if ( mytime1 != 0.0 ) { \
       mytime2 = lat_gettime(); \
       lat_record_latency(A, mytime2-mytime1 ); \
       lat_next_sample(A); \
       mytime1 = mytime2; \
       lat_record_actual_time(A,mytime1); \
    } \
    else { \
       lat_record_start(A); \
       mytime1 = lat_gettime(); \
    } \
  } \
}

#else

#define LAT_INIT(A,B)
#define LAT_DEADLINE(A,B)
#define LAT_SAMPLE(A,B)

#endif /* LATENCY_TEST */

#endif /* _LATENCY_TEST_H */
