#include "Member1.h"
#include "Member2.h"

int main( int argc, char *argv[] ) 
{
  ModuleDispatch *Dispatch;
  MemberOne *Mb1;
  MemberTwo *Mb2;
  unsigned long period1, period2;

  if ( argc != 3 ) {
     printf ( "Usage: %s <period1 in us> <period2 in us>\nPeriod=100000 -> 0.1sec\n", argv[0] );
     exit ( 1 );
  }

  period1=atol(argv[1]);
  period2=atol(argv[2]);
  printf ( "Period1 = %ld\nPeriod2 = %ld\n", period1, period2 );

  Dispatch = new ModuleDispatch( "../dcdt.conf", "hostname" );
  Mb1 = new MemberOne(Dispatch,period1);
  Mb2 = new MemberTwo(Dispatch,period2);

  LAT_INIT( 2, 100 );
   
  Dispatch->AddMember(Mb1);
  Dispatch->AddMember(Mb2);
 
  printf("\n\nPress a key to create the Community\n\n");
  getchar();

  Dispatch->ActivateMember(Mb1);
  Dispatch->ActivateMember(Mb2);

  printf("\n\nPress a key and ''let's work, be proud...'' \n\n");
  getchar();

  Dispatch->LetsWork();

  delete Mb1;
  delete Mb2;

  delete Dispatch;

  printf("\n\nCommunity Session Terminated\n\n");

  return 0;
}
