#include "SerialCommunicationAbaco.h"
#include "MotorConstants.h"

#include <sstream>

using namespace std;

SerialCommunicationAbaco::SerialCommunicationAbaco()
{
  mBaudRate = B38400;
  mModemDevice = strdup(TTYUSB0);
  mHardwareFlowControl = true;
  InitCommunication();
}

SerialCommunicationAbaco::~SerialCommunicationAbaco()
{
  stringstream serial_message;

  serial_message << "P1=0P2=0P3=0P10=1\n\r"; 

  Write(serial_message.str());

  CloseCommunication();
}


void SerialCommunicationAbaco::WriteActuations()
{
  stringstream serial_message;

  serial_message << "P0=" << mActuationValues[SHAPE] << "P1=" << mActuationValues[X_SPEED] 
		 << "P2=" << mActuationValues[Y_SPEED] << "P3=" << mActuationValues[OMEGA_SPEED] << "P10=1\n\r"; 

  Write(serial_message.str());
}


void SerialCommunicationAbaco::ReadEncoders()
{
  float n;
  char c = '\0';

  Write(ACT_X_SPEED);
  Read(&c);
  ReadNumber(&n);
  mEncoderValues[ACT_X_SPEED] = (int)n;

  Write(ACT_Y_SPEED);
  // Read(&c);
  ReadNumber(&n);
  mEncoderValues[ACT_Y_SPEED] = (int)n;

  Write(ACT_OMEGA_SPEED);
  // Read(&c);
  ReadNumber(&n);
  mEncoderValues[ACT_OMEGA_SPEED] = (int)n;

  Write(DELTA_X_RESEGHE);
  // Read(&c);
  ReadNumber(&n);
  mEncoderValues[DELTA_X] = (int)n;

  Write(DELTA_Y_RESEGHE);
  // Read(&c);
  ReadNumber(&n);
  mEncoderValues[DELTA_Y] = (int)n;

  Write(DELTA_OMEGA_RESEGHE);
  // Read(&c);
  ReadNumber(&n);
  mEncoderValues[DELTA_OMEGA] = (int)n;

  Write(RESET_ABACO);
}
