#include "SynchroActuationManager.h"
#include "MotorConstants.h"

#include <math.h>

SynchroActuationManager::SynchroActuationManager()
{}

SynchroActuationManager::~SynchroActuationManager()
{}


void SynchroActuationManager::ComputeActuations()
{
  mActuationValues.clear();
    
  if (mCommandData.find(TAN_SPEED) == mCommandData.end())
    {
      mCommandData[TAN_SPEED] = 0.0;
    }
  
  if (mCommandData.find(ROT_SPEED) == mCommandData.end())
    {
      mCommandData[ROT_SPEED] = 0.0;
    }
  
  mActuationValues[SPEED_MOTOR_DX] = (int)mCommandData[TAN_SPEED];
  mActuationValues[SPEED_MOTOR_SX] = (int)mCommandData[ROT_SPEED];  

  if (mCommandData.find(KICK) != mCommandData.end())
    {
      mActuationValues[KICK] = (int)mCommandData[KICK];
    }
}

void SynchroActuationManager::ComputeOdometry()
{
  mOdometryData[ROBOT_MOVEMENT] = mEncoderValues[ENCODER_MOTOR_DX] / 10; // mm to cm
  mOdometryData[ROBOT_DIRECTION] = mEncoderValues[ENCODER_MOTOR_SX] / 2; // radiants
  mOdometryData[ROBOT_ORIENTATION] = mEncoderValues[ENCODER_MOTOR_SX] * (180/M_PI); // degrees
  
  mOdometryData[ACT_TAN_SPEED] = mEncoderValues[SPEED_MOTOR_DX];
  mOdometryData[ACT_ROT_SPEED] = mEncoderValues[SPEED_MOTOR_SX];
}
