#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <iostream>
#include <sys/time.h>
#include <sstream>
#include <ncurses.h>

#ifdef TRISKAR
#include <TriskarActuationManager.h>
#endif

#ifdef GIANO
#include <GianoActuationManager.h>
#endif

#include "MotorConstants.h"


using namespace std;

#ifdef TRISKAR
int x_speed = 0;
int y_speed = 0;
#endif

#ifdef GIANO
int tan_speed = 0;
#endif

int rot_speed = 0;
int shape = 0;

int main(void)
{
#ifdef TRISKAR
  TriskarActuationManager motor;
#endif
#ifdef GIANO
  GianoActuationManager motor;
#endif
  char c;
  bool cont = true;

  initscr();

  
//  printf("\nInserisci il comando :\n");
//  scanf("%s",stringa);
//  input = stringa;

  while(cont)
    {
      c = getch();
//      motor.InsertData(KICK,0.0);

      switch(c)
	{
	case '8':
	  {
#ifdef TRISKAR
	    x_speed+=8;
	    if (x_speed > 128)
	      x_speed = 128;
	    motor.InsertData(TAN_X,x_speed);
#endif
#ifdef GIANO
	    tan_speed+=8;
	    if (tan_speed > 128)
	      tan_speed = 128;
	    motor.InsertData(TAN_SPEED,tan_speed);
#endif

	  }
	  break;
	case '2':
	  {
#ifdef TRISKAR
	    x_speed-=8;
	    if (x_speed < -128)
	      x_speed = -128;
	    motor.InsertData(TAN_X,x_speed);
#endif
#ifdef GIANO
	    tan_speed-=8;
	    if (tan_speed < -128)
	      tan_speed = -128;
	    motor.InsertData(TAN_SPEED,tan_speed);
#endif
	  }
	  break;
	case '4':
	  {
#ifdef TRISKAR
	    y_speed+=8;
	    if (y_speed > 128)
	      y_speed = 128;
	    motor.InsertData(TAN_Y,y_speed);
#endif
#ifdef GIANO
	    rot_speed+=4;
	    if (rot_speed > 128)
	      rot_speed = 128;
	    motor.InsertData(ROT_SPEED,rot_speed);
#endif
	  }
	  break;
	case '6':
	  {
#ifdef TRISKAR
	    y_speed-=8;
	    if (y_speed < -128)
	      y_speed = -128;
	    motor.InsertData(TAN_Y,y_speed);
#endif
#ifdef GIANO
	    rot_speed-=4;
	    if (rot_speed < -128)
	      rot_speed = -128;
	    motor.InsertData(ROT_SPEED,rot_speed);
#endif
	  }
	  break;
	case '9':
	  {
#ifdef TRISKAR
	    rot_speed-=4;
	    if (rot_speed > 128)
	      rot_speed = 128;
	    motor.InsertData(ROT,rot_speed);
#endif
#ifdef GIANO
	    rot_speed+=4;
	    if (rot_speed > 128)
	      rot_speed = 128;
	    motor.InsertData(ROT_SPEED,rot_speed);
#endif

	  }
	  break;
	case '7':
	  {
#ifdef TRISKAR
	    rot_speed+=4;
	    if (rot_speed < -128)
	      rot_speed = -128;
	    motor.InsertData(ROT,rot_speed);
#endif
#ifdef GIANO
	    rot_speed-=4;
	    if (rot_speed < -128)
	      rot_speed = -128;
	    motor.InsertData(ROT_SPEED,rot_speed);
#endif
	  }
	  break;
	case '0':
	  {
	    motor.InsertData(KICK,1.0);
	  }
	  break;
	case '.':
	  {
	    motor.InsertData(KICK,-1.0);
	  }
	  break;
	default:
	  {
#ifdef TRISKAR
	    x_speed=0;
	    y_speed=0;
	    rot_speed=0;
	    motor.InsertData(TAN_X,0.0);
	    motor.InsertData(TAN_Y,0.0);
	    motor.InsertData(ROT,0.0);
#endif
#ifdef GIANO
	    tan_speed=0;
	    rot_speed=0;
	    motor.InsertData(TAN_SPEED,0.0);
	    motor.InsertData(ROT_SPEED,0.0);
#endif
	  }
	}
      motor.ComputeActuations();
      motor.WriteActuations();
      motor.ReadEncoders(); //*wiim*
 
      
    }

}

