# KeepBall
# The robot must keep the ball while moving

## Section Module

# Section Increasing Speed

# Section Decreasing Speed

(AND	(ModuleVeryFast)
	(OR	(ProposedModuleMid)
		(OR	(ProposedModuleSlow)
			(OR	(ProposedModuleVerySlow)
				(ProposedModuleSteady)))))
							=>	(&DEL.Module ANY)(Module FAST);
(AND	(ModuleFast)
	(OR	(ProposedModuleSlow)
		(OR	(ProposedModuleVerySlow)
			(ProposedModuleSteady))))	=>	(&DEL.Module ANY)(Module MID);
(AND	(ModuleMid)
	(OR	(ProposedModuleVerySlow)
		(ProposedModuleSteady)))		=>	(&DEL.Module ANY)(Module SLOW);

(AND	(ModuleSlow)(ProposedModuleSteady))		=>	(&DEL.Module ANY)(Module VERY_SLOW);

(ModuleSteady)						=>	(Module STEADY);
(ModuleVerySlow)					=>	(Module VERY_SLOW);
(ModuleSlow)						=>	(Module SLOW);
(ModuleMid)						=>	(Module MID);
(ModuleFast)						=>	(Module FAST);
(ModuleVeryFast)					=>	(Module VERY_FAST);

(NOT (BallInKicker))					=>	(Module VERY_FAST);


## Section moves that always loose the ball

# Section Module

(AND	(NOT	(ProposedRotAhead))
	(ProposedModuleVeryFast))			=>	(&DEL.Module VERY_FAST)
								(Module FAST);

(AND	(ProposedRotRx)(ProposedModuleSteady))		=>	(&DEL.Module STEADY)	(Module SLOW)
								(&DEL.Angle ANY)	(Angle WNW)
								(&DEL.Rot ANY)		(Rot RIGHT);

(AND	(ProposedRotLx)(ProposedModuleSteady))		=>	(&DEL.Module STEADY)	(Module SLOW)
								(&DEL.Angle ANY)	(Angle ENE)
								(&DEL.Rot ANY)		(Rot LEFT);

# Section Rot

(AND	(ProposedRotFastLx)
	(NOT	(OR	(ProposedModuleSteady)
			(ProposedModuleVerySlow))))	=>	(&DEL.Rot ANY)
								(Rot LEFT);

(AND	(ProposedRotFastRx)
	(NOT	(OR	(ProposedModuleSteady)
			(ProposedModuleVerySlow))))	=>	(&DEL.Rot ANY)
								(Rot RIGHT);

(AND	(ProposedModuleVerySlow)
	(OR	(ProposedRotFastLx)(ProposedRotLeft)))	=>	(&DEL.Rot ANY)
								(Rot SLOW_LEFT);

(AND	(ProposedModuleVerySlow)
	(OR	(ProposedRotFastRx)(ProposedRotRight)))	=>	(&DEL.Rot ANY)
								(Rot SLOW_RIGHT);


## Section moves against ball position

(OR	(OR	(ProposedMoveSSWtoW)(ProposedMoveNarrowS))
	(OR	(AND	(ProposedMoveNNWtoW)(ProposedRotLx))	
		(OR 	(AND (ProposedMoveNarrowWNW)(ProposedRotAhead))
			(AND (ProposedMoveNarrowNW)(ProposedRotAhead)))))
							=>	(&DEL.Module ANY)	(Module MID)	
								(&DEL.Angle ANY)	(Angle NE)
								(&DEL.Rot ANY)		(Rot LEFT);

(OR	(ProposedMoveSSEtoE)
	(OR	(AND	(ProposedMoveNNEtoE)(ProposedRotRx))
		(OR	(AND (ProposedMoveNarrowENE)(ProposedRotAhead))
			(AND (ProposedMoveNarrowNE)(ProposedRotAhead)))))
							=>	(&DEL.Module ANY)	(Module MID)
								(&DEL.Angle ANY)	(Angle NW)
								(&DEL.Rot ANY)		(Rot RIGHT);

## Section 'tabella'

# Section ENE and WNW

(AND (ProposedMoveNarrowENE)(ProposedRotVerySlowLeft))	=>	(Rot LEFT);

(AND (ProposedMoveNarrowWNW)(ProposedRotVerySlowRight))	=>	(Rot RIGHT);

# Section NE and NW


(OR 	(AND	(ProposedMoveNarrowNE)(ProposedRotLeft))
	(AND 	(ProposedMoveNarrowNW)(ProposedRotRight)))
							=>	(Module MID);

# Section NNE and NNW

(AND	(ProposedMoveNarrowNNE)
	(OR	(AND	(ProposedModuleVerySlow)
			(OR	(ProposedRotFastLx)
				(OR	(ProposedRotLeft)
					(ProposedRotSlowLeft))))
		(AND	(OR	(ProposedModuleSlow)(ProposedModuleMid))
			(OR	(ProposedRotLeft)(ProposedRotFastLx)))))
							=>	(Rot AHEAD);

(AND	(ProposedMoveNarrowNNW)
	(OR	(AND	(ProposedModuleVerySlow)
			(OR	(ProposedRotFastRx)
				(OR	(ProposedRotRight)
					(ProposedRotSlowRight))))
		(AND	(OR	(ProposedModuleSlow)(ProposedModuleMid))
			(OR	(ProposedRotRight)(ProposedRotFastRx)))))
							=>	(Rot AHEAD);

# Section N


(AND	(ProposedMoveNarrowN)(ProposedModuleVerySlow))	=>	(&DEL.Rot ANY)
								(Rot AHEAD);

(AND	(ProposedMoveNarrowN)
	(OR	(AND	(ProposedModuleSlow)
			(OR	(ProposedRotFastLx)
				(OR	(ProposedRotLeft)
					(ProposedRotSlowLeft))))
		(AND	(OR	(ProposedModuleMid)(ProposedModuleFast))
			(OR	(ProposedRotLeft)(ProposedRotFastLx)))))
							=>	(Rot AHEAD);

(AND	(ProposedMoveNarrowN)
	(OR	(AND	(ProposedModuleVerySlow)
			(OR	(ProposedRotFastRx)
				(OR	(ProposedRotRight)
					(ProposedRotSlowRight))))
		(AND	(OR	(ProposedModuleMid)(ProposedModuleFast))
			(OR	(ProposedRotRight)(ProposedRotFastRx)))))
							=>	(Rot AHEAD);

