#include "PositionExpert.h"

#include <iostream>

extern int needodo;

PositionExpert::PositionExpert(ModuleDispatch* kernel,int period) : 
  StringModuleMember(kernel,period,"position")
{
  printf("\nPositionExpert built");
  fflush(stdout);
};

PositionExpert::~PositionExpert()
{
  printf("\nPositionExpert destroyed");
  fflush(stdout);
};

void PositionExpert::RunInit()
{
 	AddMessageRequest( MSG_FROM_MOTION,LOCAL );
 	AddMessageRequest( MSG_POSITION_P,LOCAL );
  
	lastsec=0;
	lastusec=0;
	lasttanspeed=0;
	lastrotspeed=0;
	
	rob.x=STARTX;
	rob.y=STARTY;
	rob.a=STARTANGLE;
	
	settimer(1);

  	printf("\nPositionExpert initialized");
  	fflush(stdout);
};

/* ***********************************
   
   DoYourDuty()

   *********************************** */

void PositionExpert::RunDuty()
{
  	unsigned char* buffer;
  	unsigned char* buffer2;
	char* buf;
	float f;
	int i;
	float e;
	float tanspeed,rotspeed;
	int odovalid=0;
	

		
		
  
  	if(ReceiveLastMessage(MSG_POSITION_P, buffer,true) > 0){
  		if(strtovalue((char*)buffer,"invalidposition ",&f)){
  			//printf("vision not working\n");
		}else{
			needodo=0;
			settimer(1);
			if(strtovalue((char*)buffer,"posx ",&f)){
				rob.x=f;
			}
			if(strtovalue((char*)buffer,"posy ",&f)){
				rob.y=f;
			}
			if(strtovalue((char*)buffer,"angle ",&f)){
				rob.a=f;
			}
			NewMessage(MSG_POSITION,POS_DATA);
  			mCurrentMessage<<buffer;
  			SendAllStringMessages();
  			firstodo=1;
  			return;
		}
		if(elapsed(1)>NOTVISIONLIMIT){
 			NewMessage(MSG_POSITION,POS_DATA);
  			mCurrentMessage<<"invalidposition ";
  			SendAllStringMessages();
		}else{
			needodo=1;
			if(ReceiveLastMessage(MSG_FROM_MOTION, buffer2,true) > 0){
				for(i=0;buffer2[i]!=NULL;i++){
					;
				}
    			buf=(char*)malloc(i+1);
    			strcpy(buf,(char*)buffer2);

				//printf("%s\n",buf);
				e=((float)elapsedtime(buf))/1000000;
				if(firstodo){
					e=0;
				}
				//printf("%f\n",e);
				
				f=0;
    			if(strtovalue(buf,"movement ",&f)){
    				lasttanspeed=f * ODOTANSCALE;
				}else{
					lasttanspeed=0;
				}
				f=0;
       			if(strtovalue(buf,"orientation ",&f)){
       				lastrotspeed=f * ODOROTSCALE;
				}else{
					lastrotspeed=0;
				}
				
				rob.a+=lastrotspeed*e;
				rob.a=norangle(rob.a);
				rob.x+=lasttanspeed*(cos(degtorad(rob.a)))*e;
				rob.y+=lasttanspeed*(sin(degtorad(rob.a)))*e;
				NewMessage(MSG_POSITION,POS_DATA);
				mCurrentMessage<<" posx "<<rob.x<<" posy "<<rob.y<<" angle "<<rob.a<<" \n";
				//cout<<mCurrentMessage.str();
				CloseMessage();
				SendAllStringMessages();
				
  				printf("odometria %d\n",firstodo);
  				firstodo=0;
			}
		}
	}
	
  		

};

void PositionExpert::RunClose()
{
  printf("\nPositionExpert closed");
  fflush(stdout);
};

long PositionExpert::elapsedtime(char* buf)
{
	long sec,usec,e;
	int i;
	int t=0;
	char* buf10=(char*)malloc(50);
	char* buf11=(char*)malloc(50);
	char* buf12=(char*)malloc(50);

	sscanf(buf,"%*s%*s%*s%*s%*s%*s%*s%*s%*s%s",buf10);
	for(i=1;buf10[i]!=NULL;i++){
		if(buf10[i]=='_'){
			i++;
			t=i;
			//i+=2;
		}
		if (t==0){
			buf11[i-1]=buf10[i];
		}else{
			buf12[i-t]=buf10[i];
		}
	}
	buf11[t-2]=NULL;
	buf12[i-t]=NULL;
	
	sscanf(buf11,"%d",&sec);
	sscanf(buf12,"%d",&usec);
	
	free (buf10);
	free (buf11);
	free (buf12);
	
	if(lastsec==0){
		lastsec=sec;
		lastusec=usec;
		return 0;
	}else{
		e=(((sec-lastsec)*1000000)+(usec-lastusec));
		lastsec=sec;
		lastusec=usec;
		return e;
	}
}
	
long PositionExpert::elapsed(int i)
{ 
	struct timeval now;
	long elapsed_usec = 0;

	gettimeofday(&now, NULL);

	if (now.tv_usec > 1000000) {
		now.tv_usec -= 1000000;
		++now.tv_sec;
	}

	if (now.tv_sec > last_render[i].tv_sec){
		elapsed_usec = ((now.tv_sec - last_render[i].tv_sec) * 1000000);
	}

	if (now.tv_usec > last_render[i].tv_usec)
		elapsed_usec += now.tv_usec - last_render[i].tv_usec;
	else
		elapsed_usec -= last_render[i].tv_usec - now.tv_usec;


	return elapsed_usec ;

}

void PositionExpert::settimer(int i)
{
	gettimeofday(&(last_render[i]),NULL);
	return;
}

