#ifndef VisionExpert_h
#define VisionExpert_h

#include "const.h"
#include "type.h"
#include "StringModuleMember.h"
#include "Matrix3DRotoTraslation.h"
#include "Param3DRotoTraslation.h"
#include <InverseMatrixCorrection.h>
#include "MatrixFunctions.h"

#undef INC_ART //questo serve altrimenti non compila!! le artoolkitplus sono un po' scritte con il ...
#include "ARToolKitWrapper.h"

#include "VideoAcquisitionWheelchair.h"
#include "FireIAcquisition.h"
#include "FileRawAcquisition.h"
#include "GestioneConfigurazione.h"
#include "GestioneCoordinateAssolute.h"

using namespace std;

class VisionExpert : public StringModuleMember{
public:
	VisionExpert (ModuleDispatch* kernel, int period,bool simFileCamera=false,string prefix="img",string postfix="",string format="%10d");
	~VisionExpert ();
	void RunInit();
	void RunClose();
	void RunDuty();
	bool isReady();
private:
	VideoAcquisitionWheelchair *camera;
	InverseMatrixCorrection *invMat;
	ARToolKitWrapper *art;
	GestioneCoordinateAssolute * coordAss;
	struct timeval 	tstart;
	
	int initInvMatFromFile();
	int initCoordAssFromFile();
	int initCoordAssPostFromFile();
	
	weightfloat posx_array[POSITIONFILTER];
	weightfloat posy_array[POSITIONFILTER];
	weightfloat posa_array[POSITIONFILTER];
};
#endif
