#include "WiimExpert.h"
#include "MotorConstants.h"
#include <msg.h>

#include <iostream>

#include <string>

#define MAXSTR	200

using namespace std;

// la parola extern non dichiara un nuovo identificatore, 
// ma dice "La variabile intera a e` dichiarata da qualche altra parte, 
// lascia solo lo spazio per risolvere il riferimento"

extern int MessageLineNum;
extern struct wiimote_t* wm0;

WiimExpert::WiimExpert(ModuleDispatch* kernel,int period) : 
  StringModuleMember(kernel,period,"WiimExpert")
{
  printf("\nWiimExpert built");
  fflush(stdout);
};

WiimExpert::~WiimExpert()
{
  fclose(fp);
  printf("\nWiimExpert destroyed");
  fflush(stdout);
};

void WiimExpert::RunInit()
{
	int i=0;
	
	charged=0;
	Hit=0;
	gHome=0;
	restartflag=0;
	rotflag=0;
	fps=0;
	random_sign=1;
	
	settimer(0);
	settimer(1);
	settimer(2);
	settimer(3);
	settimer(4);
	
	center.x=0;
	center.y=0;
	home.x=STARTX;
	home.y=STARTY;
	home.a=STARTANGLE;
	goal.x=GOALX;
	goal.y=GOALY;
	rob.x=home.x;
	rob.y=home.y;
	rob.a=home.a;
	
	robotpoint=0;
	humanpoint=0;
	pointrobotflag=0;
	
	maxx=-2000;
	maxy=-2000;
	minx=2000;
	miny=2000;
	
	for(i=0;i<IRCENTERFILTER;i++){
		ir_centerarray_x[i].v=0;
		ir_centerarray_x[i].w=0;
		ir_centerarray_y[i].v=0;
		ir_centerarray_y[i].w=0;
	}
	
	AddMessageRequest( MSG_POSITION,LOCAL );
	
	wiim = new Wiim(); //inizializza (connessione al wiimote)
	
	struct timeval now;
	gettimeofday(&now,NULL);
    base_time=now.tv_sec;
	fp = fopen(POSITIONLOG,"a");
	fprintf(fp,
"#time\tx\ty\ta\tabstimeh\tabstimel\tir1v\tir1x\tir1y\tird1x\tird1y\tir2v\tir2x\tir2y\tird2x\tird2y\tir3v\tir3x\tir3y\tird3x\tird3y\tir4v\tir4x\tir4y\tird4x\tird4y\tircv\tircx\tircy\n");
  	 
  	printf("\nWiimExpert initialized");
  	fflush(stdout);
};

/* ***********************************
   
   DoYourDuty()

   *********************************** */
   

void WiimExpert::RunDuty()
{
	//printf("sono wiim\n");
	int i=0;
	float dir;
	float acc;
	static int positioninvalid=0;
	
	ppoint ir_center;
	float ir_centerx,ir_centery;
	int ir_centervalid;
	weightfloat newdata;
	weightfloat ir_newcenterx,ir_newcentery;
	float ir_center_distance;
	
	string str;
	unsigned char* buffer;
	
	if((ReceiveLastMessage(MSG_POSITION, buffer,false) > 0)){
   		//printf ("\nricevuto log: \n%s\n",buffer);
    		for(i=0;buffer[i]!=NULL;i++){
				;
			}
			float f;
    		char* buf=(char*)malloc(i+1);
    		strcpy(buf,(char*)buffer);
			if(strtovalue(buf,"position_data",NULL)){
				if(strtovalue(buf,"invalidposition ",&f)){
					printf("posizione non valida!\n");
					positioninvalid=1;
				}else{
					positioninvalid=0;
				}	
				if(strtovalue(buf,"posx ",&f)){
					rob.x=f;
				}
				if(strtovalue(buf,"posy ",&f)){
					rob.y=f;
				}
				if(strtovalue(buf,"angle ",&f)){
					rob.a=f;
				}

				
			}
			//printf("x: %f ,y: %f ,a: %f\n",rob.x,rob.y,rob.a);		
	}
	
	if(!wiim->run()){
		return; //facciamo qualcosa solo se c'e' un "evento" sul wiimote
				//il wiimote genera sempre un evento ogni 1/100 di secondi
				//quindi il wiimote sincronizza tutto
	}
	if(wm0==NULL){
		return;
	}
	
	struct timeval now;
	float t;
  	gettimeofday(&now,NULL);
  	//printf("%f       %f\n",base_time,rob.x);
  	t=now.tv_sec-base_time;
	fprintf(fp,"%f\t%f\t%f\t%f\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n",(float)((t*1000))+round(((float)(now.tv_usec))/1000),rob.x,rob.y,rob.a,
	now.tv_sec,now.tv_usec,
	wm0->ir.dot[0].visible,wm0->ir.dot[0].rx,wm0->ir.dot[0].ry,wm0->ir.dot[0].x,wm0->ir.dot[0].y,
	wm0->ir.dot[1].visible,wm0->ir.dot[1].rx,wm0->ir.dot[1].ry,wm0->ir.dot[1].x,wm0->ir.dot[1].y,
	wm0->ir.dot[2].visible,wm0->ir.dot[2].rx,wm0->ir.dot[2].ry,wm0->ir.dot[2].x,wm0->ir.dot[2].y,
	wm0->ir.dot[3].visible,wm0->ir.dot[3].rx,wm0->ir.dot[3].ry,wm0->ir.dot[3].x,wm0->ir.dot[3].y
	);
	
	
	if(rob.x>maxx){
		maxx=rob.x;
	}
	if(rob.y>maxy){
		maxy=rob.y;
	}
    if(rob.x<minx){
		minx=rob.x;
	}
	if(rob.y<miny){
		miny=rob.y;
	}
	//printf("x: %f ,y: %f ,a: %f mx: %f , mx: %f , my: %f ,my: %f , dx: %f , dy: %f \n",rob.x,rob.y,rob.a,maxx,minx,maxy,miny,fabs(maxx-minx),fabs(maxy-miny));		
	
	
	ir_center=wiim->getcenter();
	if (ir_center.valid==0){
		newdata.w=0;
		ir_newcenterx=getFilteredData(newdata,ir_centerarray_x,IRCENTERFILTER,IRCENTERATT,NULL);
		ir_newcentery=getFilteredData(newdata,ir_centerarray_y,IRCENTERFILTER,IRCENTERATT,NULL);
		if(ir_newcenterx.w==0 || ir_newcentery.w==0){
			ir_centervalid=0;
		}
	}else{
		newdata.w=1;
		newdata.v=ir_center.x;
		ir_newcenterx=getFilteredData(newdata,ir_centerarray_x,IRCENTERFILTER,IRCENTERATT,NULL);
		newdata.v=ir_center.y;
		ir_newcentery=getFilteredData(newdata,ir_centerarray_y,IRCENTERFILTER,IRCENTERATT,NULL);
		ir_centervalid=1;
	}
	ir_centerx=ir_newcenterx.v;
	ir_centery=ir_newcentery.v;	
	if(ir_centervalid==1){
		ir_center_distance=sqrt(pow((ir_centerx-1024/2),2)+pow((ir_centery-768/2),2));
	}
	
	struct timeval now2;
	float t2;
  	gettimeofday(&now2,NULL);
  	//printf("%f       %f\n",base_time,rob.x);
  	t2=now2.tv_sec-base_time;
	fprintf(fp,"%f\t%f\t%f\t%f\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%f\t%f\n",(float)((t2*1000))+round(((float)(now2.tv_usec))/1000),rob.x,rob.y,rob.a,
	now.tv_sec,now.tv_usec,
	wm0->ir.dot[0].visible,wm0->ir.dot[0].rx,wm0->ir.dot[0].ry,wm0->ir.dot[0].x,wm0->ir.dot[0].y,
	wm0->ir.dot[1].visible,wm0->ir.dot[1].rx,wm0->ir.dot[1].ry,wm0->ir.dot[1].x,wm0->ir.dot[1].y,
	wm0->ir.dot[2].visible,wm0->ir.dot[2].rx,wm0->ir.dot[2].ry,wm0->ir.dot[2].x,wm0->ir.dot[2].y,
	wm0->ir.dot[3].visible,wm0->ir.dot[3].rx,wm0->ir.dot[3].ry,wm0->ir.dot[3].x,wm0->ir.dot[3].y,
	ir_centervalid,ir_centerx,ir_centery
	);
	
	
	//printf("-- %d --- %d --- %d\n",now.tv_sec,now.tv_usec,elapsed(0));
	if(elapsed(0)>1000000){
		settimer(0);
		printf("WiimExpert fps:%d     ",fps);
		printstatus();
		fps=0;
	}else{
		fps++;
	}
	//printf("\n%f\t\%f\t%f\t%d\t%d\t%d",ir_center_distance,ir_centerx,ir_centery,ir_center.x,ir_center.y,ir_centervalid);
	// --- blocco d'emergenza ---
	if (wiim->getEmergencyStop() || positioninvalid){
		NewMessage(MSG_TO_MOTION,WIIMOTE_DATA);
		mCurrentMessage<<"<C>TanSpeed 0.0</C>\n"<<"<C>RotSpeed 0.0</C>\n" << "</MESSAGE>\n" << '\0';
		//implemetare chiusura programma?
		SendAllStringMessages();
		/*rob.x=home.x;
		rob.y=home.y;
		rob.a=home.a;*/
		//return; //questo messaggio è prioritario, non ne cerco di altri
	}
	
	// --- goto Home ---
	if(wiim->getJButtonHome()){
			gHome=!gHome;
	}
	
	// --- messaggi da inviare direttamente ai motori --- 
	if(!(wiim->IsAuto())){
		str="";
		str=wiim->getToMotor();
		if (str!=""){
			NewMessage(MSG_TO_MOTION,WIIMOTE_DATA);
			//*wiim* da modificare, questo comunque è un messaggio valido
			// si potrebbero usare le funzioni in StringMessageManager 
			mCurrentMessage<< "<C>"<<str<<"</C>\n";
			CloseMessage();
			SendAllStringMessages();
		}else{
			NewMessage(MSG_TO_MOTION,WIIMOTE_DATA);
			mCurrentMessage<<"<C>TanSpeed 0.0</C>\n"<<"<C>RotSpeed 0.0</C>\n" << "</MESSAGE>\n" << '\0';
			SendAllStringMessages();
		}
		//return; //questi messaggi hanno la priorita', non ne cerco di altri;
	}
	

		
	
	// --- messaggi al log ---
	// posizione del centro (inviare solo se c'e' un centro valido?)
	NewMessage(MSG_TO_LOG,WIIMOTE_DATA);
	if(ir_centervalid){
		mCurrentMessage << "valid 1 xcenter "<<ir_centerx<<" ycenter "<<ir_centery;
	}else{
		mCurrentMessage << "valid 0 xcenter 0 ycenter 0";
	}
	//printf("%d %f %f \n",ir_centervalid,ir_centerx,ir_centery);
	CloseMessage();
	SendAllStringMessages();
	
	
	
	// --- messaggi per brian ---
	if (!(wiim->IsAuto()) ||positioninvalid){
		//printf("manual\n");
		/*NewMessage(MSG_TO_BRIAN,WIIMOTE_DATA);
		mCurrentMessage << "</MESSAGE>\n" << '\0';
		SendAllStringMessages();*/
		Hit=0;
		return; //mando un messaggio vuoto a brian (wiimexpert è l'unico che manda messaggi a brian!)
	}/*else{
		//printf("auto\n");
	}*/
	
	NewMessage(MSG_TO_BRIAN,WIIMOTE_DATA);
	//meccanica gioco
	
	/*if (wiim->getHButtonA()){
		wiim->showPoint(humanpoint-robotpoint);
	}*/
	
	//carica
	wiim->SetCharge(charged);
	if (ir_centervalid){
		//printf("--- %f ---\n",d);
		if(ir_center_distance<IRCENTERLIMIT){
			if(charged<5){
				charged += 0.01;
			}
		}else{
			if(charged >=0){
				charged -= 0.01;
			}
		}
	}else{
		if(charged >=0){
			charged -= 0.01;
		}
	}
	//printf("%f\n",charged);
	if(charged>4){
		if(wiim->getButtonB() && ir_center_distance<IRCENTERHIT){
			if(Hit==0 && !gHome){ //solo se sono visibili 2 luci?
				Hit=1;
				charged=0;
				printf("--- *** COLPITO! *** ---\n");
				humanpoint++;
				wiim->SetpointDiff(humanpoint-robotpoint);
				wiim->BlinkRight(1);
				wiim->StrongRumble(1);
				wiim->SetpointDiff(humanpoint-robotpoint);
			}
		}
	}
	if(wiim->getButtonB()){
		if(charged>2){
			wiim->WeakRumble(1);
		}
		charged=0;
	}
	//messaggio di colpito (per brian)
	if(Hit || gHome){
		charged=0;
		/*if (ppdistance(rob,home).d<15){
			rotflag++;
			//printf("+++%d\n",rotflag);
		}else{
			if(rotflag<10){
				rotflag=0;
			}
		}*/
		AddBrianData("Hit",1,0.9);
		if(restartflag){
			printf("***restartflag %d\n",restartflag);
		}		
		if (ppdistance(rob,home).d<HOMERADIUS/*+35 && fabs(a360to180(home.a-rob.a))<15 && rotflag*/){
			if(restartflag==0){
				settimer(1);
			}
			restartflag=1;
			//printf("%d\n",elapsed(1));
			if(elapsed(1)>3000000){
				if(rotflag==0){
					rotflag=1;
					settimer(4);
				}
			}
		}else{
			if(rotflag==0){
				//restartflag=0;
			}
		}
	}else{
		AddBrianData("Hit",0,0.9);
	}
	
	if(rotflag==1){
		//printf("***rotflag\n",rotflag);
		AddBrianData("HomeRot",1,0.9);
	}else{
		AddBrianData("HomeRot",0,0.9);
	}
	if(rotflag && elapsed(4)>5000000){
		restartflag=0;
		Hit=0;
		gHome=0;
		rotflag=0;
		printf("--- *** si riparte! *** ---\n");
		wiim->WeakRumble(1);
	}
	
	//punto robot
	//printf("%f ---\n",ppdistance(rob,goal).d);
	if(ppdistance(rob,goal).d<GOALRADIUS && !gHome){
		if(pointrobotflag){
			if(elapsed(2)>3000000){
				robotpoint++;
				printf("--- *** punto per il robot *** ---\n");
				pointrobotflag=0;
				gHome=1;
				wiim->SetpointDiff(humanpoint-robotpoint);
				wiim->BlinkLeft(1);
				wiim->StrongRumble(1);
			}
		}else{
			settimer(2);
			pointrobotflag=1;
		}
	}else{
		pointrobotflag=0;
	}
	
	
	//messaggi accellerazione
	acc = wiim->GetAcceleration();
	acc -=1;
	acc= fabs(acc);
	
	if (elapsed(3)>2500000){
		settimer(3);
		random_sign = -random_sign;
	}
	if (acc > 0.15){
		//printf("moving %f ...\n",acc);
		AddBrianData("GAcc",acc*10,0.9);
	}else{
		AddBrianData("GAcc",0,0.9);
	}
	AddBrianData("Random",random_sign,0.9);
	AddBrianData("WiiMotePitch",wiim->getPitch(),0.9);
	
	
	//messaggio distanza e direzione dal centro IR (per brian)
	
	if(ir_centervalid){
		if(ir_centerx<1024/2){
			AddBrianData("IRCenter",-1*ir_center_distance,0.9);
		}else{
			AddBrianData("IRCenter",+1*ir_center_distance,0.9);
		}
	}
	
	//messaggi distanza da goal/home/centro,...
	//printf("d=%f, a=%f\n",ppdistance(rob,goal).d,ppdistance(rob,goal).a);
	
	AddBrianData("DtoGoal",ppdistance(rob,goal).d,0.9);
	AddBrianData("AtoGoal",ppdistance(rob,goal).a,0.9);
	AddBrianData("DtoCenter",ppdistance(rob,center).d,0.9);
	AddBrianData("AtoCenter",ppdistance(rob,center).a,0.9);
	AddBrianData("DtoHome",ppdistance(rob,home).d,0.9);
	AddBrianData("AtoHome",ppdistance(rob,home).a,0.9);
	AddBrianData("ARobot",a360to180(home.a-rob.a),0.9);	
	
	//chiudo e invio
	CloseMessage();
	SendAllStringMessages();


	
}


void WiimExpert::RunClose()
{
  printf("\nWiimExpert closed");
  fflush(stdout);
};

void WiimExpert::AddBrianData(char* name,float value,float rel)
{
	float v;
	float r;
	
	v=value;
	r=rel;
	if(fabs(v)<0.001){ //evito che vengano mandati valori in notazione scientifica
		v=0;
	}
	if(fabs(r)<0.001){
		v=0;
	}
	
	mCurrentMessage<<"<D>"<<name<<" "<<v<<" "<<r<<" </D>\n";
	return;
	
}

long WiimExpert::elapsed(int i)
{ 
	struct timeval now;
	long elapsed_usec = 0;

	gettimeofday(&now, NULL);

	if (now.tv_usec > 1000000) {
		now.tv_usec -= 1000000;
		++now.tv_sec;
	}

	if (now.tv_sec > last_render[i].tv_sec)
		elapsed_usec = ((now.tv_sec - last_render[i].tv_sec) * 1000000);

	if (now.tv_usec > last_render[i].tv_usec)
		elapsed_usec += now.tv_usec - last_render[i].tv_usec;
	else
		elapsed_usec -= last_render[i].tv_usec - now.tv_usec;


	return elapsed_usec ;

}

void WiimExpert::settimer(int i)
{
	gettimeofday(&(last_render[i]),NULL);
	return;
}

void::WiimExpert::printstatus()
{
	printf("carica: %f\t",charged); 
	if(Hit){
		printf("Colpito!\t");
	}
	if(gHome){
		printf("goto Home\t");
	}
	if(rotflag){
		printf("rotflag\t");
	}
	printf(" hum:%d rob:%d\t",humanpoint,robotpoint);
	printf("\n");
}







		

