%{
#ifndef BRIAN_Y
#define BRIAN_Y
  //include files and global variables
#include "BrianExpert.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif
#endif
  extern int yylex();
  int MessageLineNum;

  int brianerror(char* s);

  BrianExpert* pBrian = 0;

%}

%union {
  float value;
  char* string;
}

%token OPEN_MESSAGE_HEADER
%token CLOSE_HEADER CLOSE_MESSAGE 
%token EQUAL
%token MESSAGE_ID TIMESTAMP SENDER MODULE 
%token OPEN_DATUM CLOSE_DATUM
%token OPEN_ENCODER CLOSE_ENCODER
%token <string> NAME
%token <value> VALUE

%start message_queue

%%

message_queue:
	     | message message_queue
             ;

message: OPEN_MESSAGE_HEADER 
	 CLOSE_HEADER 
	 crisp_data_list
	 CLOSE_MESSAGE
       ;

crisp_data_list:
	       | crisp_data crisp_data_list
	       ;

crisp_data: OPEN_DATUM NAME VALUE VALUE CLOSE_DATUM
	  {
	    pBrian->SetValue($2,$3,$4);
	    free($2);
	  }
          | OPEN_ENCODER NAME VALUE CLOSE_ENCODER
	  {
	    pBrian->SetValue($2,$3,1.0);	    
	    free($2);
	  }
	  ;
%%

int brianerror(char* s)
{
  printf ("BRIAN:%s alla riga %d\n", s, MessageLineNum);
  return 1;
}

void brianparser(BrianExpert* brian)
{
  MessageLineNum=1;
  pBrian = brian;
  brianparse();
}
