%option noyywrap

%{
#include "MotorExpert.h"

#include "motorgram.tab.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif

extern int motorlex();

extern void motorparser (MotorExpert* pMotor);

void motorlex_memory(const char* src, MotorExpert* pMotor)
{
//   cout << src << endl;
   YY_BUFFER_STATE buf_state;
   buf_state = motor_scan_string(src);
   motorparser (pMotor);
   motor_delete_buffer(buf_state);
}

extern int MessageLineNum;

%}


%option noyywrap
%pointer


TEXT [a-zA-Z_][a-zA-Z0-9_]*
BLANK [" "\t]
DIGIT [0-9]
SPACE [" "]
%x HEADER
%%

"#".*           /* eat up comments */
{BLANK}+        /* eat blank spaces */
\n              /* eat up all newline*/ {MessageLineNum++;}

"<MESSAGE"	{ BEGIN(HEADER); 
		  return OPEN_MESSAGE_HEADER;}
<HEADER>">"     { BEGIN(INITIAL); 
		  return CLOSE_HEADER;}
<HEADER>.	{}
">"		{ return CLOSE_HEADER;}
"</MESSAGE>"    { return CLOSE_MESSAGE;}
"="             { return EQUAL;}
"id"            { return MESSAGE_ID;}
"timestamp"     { return TIMESTAMP;}
"sender"        { return SENDER;}
"module"        { return MODULE;}

"<C>"		{ return OPEN_COMMAND;}
"</C>"		{ return CLOSE_COMMAND;}


{TEXT}          {  
		  motorlval.string = (char*)strdup(motortext); 
		  return NAME; 
		}

[-+]?{DIGIT}+(\.{DIGIT}+)?	{	
				  *(motortext+motorleng)='\0';
				  motorlval.value=atof(motortext);
				  return VALUE;
				}
%%