%{
#ifndef MOTORGRAM_Y
#define MOTORGRAM_Y
  //include files and global variables
#include <string>
#include "MotorExpert.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif
#endif
  extern int yylex();
  extern int MessageLineNum;

  MotorExpert* pMotor;

  int motorerror(char* s);
%}

%union {
  float value;
  char* string;
}

%token OPEN_MESSAGE_HEADER
%token CLOSE_HEADER CLOSE_MESSAGE 
%token EQUAL
%token MESSAGE_ID TIMESTAMP SENDER MODULE 
%token OPEN_COMMAND CLOSE_COMMAND

%token <string> NAME
%token <value> VALUE

%start message_queue

%%

message_queue:
	     | message message_queue
             ;

message: OPEN_MESSAGE_HEADER 
	 CLOSE_HEADER 
	 command_data_list
	 CLOSE_MESSAGE
       ;

command_data_list:
	        | command_data command_data_list
	        ;

command_data: OPEN_COMMAND NAME VALUE CLOSE_COMMAND
	  {
	    pMotor->InsertData((string)$2,$3);
	    free($2);
	  }
	  ;
%%

int motorerror(char* s)
{
  printf ("MOTOR:%s alla riga %d\n", s, MessageLineNum);
  return 1;
}

void motorparser(MotorExpert* motor)
{
  pMotor = motor;
  motorparse();
}
