#ifndef FireIAcquisition_h
#define FireIAcquisition_h

#include <stdio.h>
#include <libraw1394/raw1394.h>
#include <libdc1394/dc1394_control.h>
#include <stdlib.h>
#include "VideoAcquisitionWheelchair.h"
#include <string>
using namespace std;

class FireIAcquisition : public VideoAcquisitionWheelchair{
public:

	FireIAcquisition(string nameDev,bool flagSaveFrame=false,string p="",string s="",string f="");

	~FireIAcquisition();

	void Start();
	bool isReady();
	void Stop();
	unsigned char* CaptureFrame();

	inline int getCount(){return count;};


private:
	dc1394_cameracapture mCamera;
	raw1394handle_t mHandle;
	nodeid_t* mCameraNodes;
	unsigned char * mpImage;
	string deviceName;

	int count;
	bool saveFrame;
	string prefix;
	string suffix;
	string iformat;

	static const int image_width 	=640;
	static const int image_height 	=480;
	static const int format = FORMAT_VGA_NONCOMPRESSED;
	static const int mode   = MODE_640x480_MONO;
	static const int framerate = FRAMERATE_30;
	static const int channel = 0;
	static const int num_dma_buffers=30;
	static const int drop_frames=1;
	static const int firewire_speed =SPEED_400;

};


#endif
