#ifndef Param3DRotoTraslation_h
#define Param3DRotoTraslation_h

#include "Matrix3DRotoTraslation.h"
#include "math.h"

class Param3DRotoTraslation{
	double x,y,z;
	double sa,sb,sc;
	double ca,cb,cc;
public:
	Param3DRotoTraslation();
	~Param3DRotoTraslation();
	
	inline void setX(double px){x=px;};
	inline void setY(double py){y=py;};
	inline void setZ(double pz){z=pz;};
	inline void setA(double pa){sa=sin(pa);ca=cos(pa);};
	inline void setB(double pb){sb=sin(pb);cb=cos(pb);};
	inline void setC(double pc){sc=sin(pc);cc=cos(pc);};
	inline void setA(double psa,double pca){sa=psa;ca=pca;};
	inline void setB(double psb,double pcb){sb=psb;cb=pcb;};
	inline void setC(double psc,double pcc){sc=psc;cc=pcc;};

	inline double getX(){return x;};
	inline double getY(){return y;};
	inline double getZ(){return z;};
	inline double getSinA(){return sa;};
	inline double getSinB(){return sb;};
	inline double getSinC(){return sc;};
	inline double getCosA(){return ca;};
	inline double getCosB(){return cb;};
	inline double getCosC(){return cc;};
	inline double getA(){return atan2(sa,ca);};
	inline double getB(){return atan2(sb,cb);};
	inline double getC(){return atan2(sc,cc);};

};

#endif
