function y = fuzzy_table (table, number_input)
if number_input == 1
    fp = fopen('first_input.dat','wt');
else 
    fp = fopen('second_input.dat','wt');
end
% Lo script funziona con 3, 5 o 7 membership function
fuzzy_input_1 = [];
fuzzy_input_mfs = [];
temp_mf_inf_value = 0;
temp_mf_value = 0;
temp_mf = [];
temp_mf_inf = [];
error=0;

mf_number = 0;
dim = size(table);
i_max = dim(1,2); % number of MFs
j_max = dim(1,1); % number of different values 

if (i_max ~= 3) && (i_max ~= 5) && (i_max ~= 7)
    error('Input is not valid');
    return;
end
mf_number = i_max;

% la tabella deve avere grandezza 201! Verr ridotta in una da 101
if j_max < 201
    % la tabella non  accettabile
    error('Table is too short');
    
elseif j_max > 201
    % la tabella non  accettabile
    error('Table is too large');
end

% testing on symmetry
error_on_symmetry = 0;
zero_mf = ceil(i_max/2); %round towards plus infinity
for j = 1:100
    error_tot = false;
    
    % difference in the zero membership function
    diff = table(j,zero_mf) - table( (j_max-j),zero_mf); 
    if diff > 0.1 || diff < -0.1
        error_on_symmetry = error_on_symmetry  + 1;
    end
    
    for k = 1:(zero_mf-1)
        diff = 0;
        diff = table(j,(zero_mf-k)) - table( (j_max-j),(zero_mf+k));
        if diff > 0.1 || diff < -0.1
            error_on_symmetry = error_on_symmetry  + 1;
        end
    end
end
error_on_symmetry

% error_on_symmetry must be lower then 10% of number of elements
if error_on_symmetry > 20
    error('Membership functions are NOT symmetric')
end

% se l'errore di simmetria  basso => table(100:201,:) per prenderne la met

half_table = table(101:201,:); % half_table has the same elements of table from 101 ( value 0) to the last value
dim = size(half_table);
i_max = dim(1,2); % number of MFs
j_max = dim(1,1); % number of different values 

% Algorithm generates out_table
% first column: value of mf
% second column: number of first matched mf
% third column: number of second matched mf
i=0; j=0; 
for j = 1:j_max
    temp = 0;
    temp_mf_value=0;
    for i = 1:i_max
        temp = temp + half_table(j,i);
        % Per ogni valore prendo la prima mf diversa da 0
        if (half_table(j,i) ~= 0) 
            temp_mf_value = half_table(j,i);
            temp_mf = i; % first mf found
            temp_mf_inf_value = i + 1; % mf after the first one
            break
        end
    end
    fuzzy_input_1 = [fuzzy_input_1 ; temp_mf_value];
    fuzzy_input_mfs = [fuzzy_input_mfs ; temp_mf];
    temp_mf_inf = [temp_mf_inf ; temp_mf_inf_value];
    if ( temp > 0.99 && temp < 1.01 )% sum of MFs must be exactly 1 
    else error = error+1; 
    end
end
%error
out_table = [fuzzy_input_1 fuzzy_input_mfs temp_mf_inf]

% This algorithm generates file in which we save results.
% We code each line into a bit 
% out_table(1,1) * 63
dim = size(out_table);
i_max = dim(1,2); 
j_max = dim(1,1);
new_table = [];
biz=0; j=0;

for j = 1:j_max
    
    if mf_number == 5 || mf_number == 7
        if ( out_table(j,2) == 3 ) && ( out_table(j,3) == 4 )
            % bit_1 & bit_2 = 0
            biz = 0;
        elseif ( out_table(j,2) == 4 ) && ( out_table(j,3) == 5 )
            % bit_1 = 1 & bit_2 = 0
            biz = 128;
        elseif ( out_table(j,2) == 5 ) && ( out_table(j,3) == 6 )
            % bit_1 = 1 & bit_2 = 1
            biz = 192;
        else error('Combinazione di mf non accettata\n');
        end
    elseif mf_number == 3
        %diverso
        if ( out_table(j,2) == 2 ) && ( out_table(j,3) == 3 )
            % bit_1 & bit_2 = 0
            biz = 0;
        elseif ( out_table(j,2) == 3 ) && ( out_table(j,3) == 4 )
            % bit_1 = 1 & bit_2 = 0
            biz = 128;
        else error('Combinazione di mf non accettata\n');
        end
    end
    new_table(j) = round(out_table(j,1)*63) + biz;
end
fprintf(fp, '%g \n', new_table);
fclose(fp);
return


